# -*- coding:Utf8 -*-
#
# Classe_Point_Cours.py

#######################################################
# PREMIERS PAS AVEC LES CLASSES                       #
# (C) Gérard Swinnen, 2015 CHAPITRE 13 P.142          #
# (C) Gérard Swinnen, 2010 CHAPITRE 11 P.191          #
# Exemple codé P.G                                    #
#######################################################

from math import sqrt

def calculDistance(a,b):
    """Calcul de la distance entre deux points"""
    return sqrt((a.x-b.x)**2 + (a.y-b.y)**2)

## DEFINITION D'UNE CLASSE POINT
#  La création d'une instance (ou d'un objet) créé dans l'espace de nom
#  de l'objet deux attributs d'instance x et y.
#  C'est le constructeur __init__ qui s'en charge automatiquement
#  une valeur initiale est proposée x=0 et y=0
class Point:
    """Définition d'un point géométrique """
    
    def __init__(self,x=0,y=0):
        self.x = x
        self.y = y
        
## PROGRAMME PRINCIPAL SI UTILISE EN DIRECT
if __name__=='__main__':
    print("Création d'un point p1 de coordonnées (1,4)")
    p1 = Point(1,4)
    print("Documentation intégrée à l'objet : ",p1.__doc__)    
    print("Création d'un point p2 de coordonnées (4,6)")    
    p2 = Point(4,6)    
    print("Calcul de la distance p1-p2 %7.3f " % (calculDistance(p1,p2)))
    print("Documentation intégrée de la fonction calculDistance : ",calculDistance.__doc__)    
    print("Coordonnées du point p1")
    print(p1.x)
    print(p1.y)
    print("Création d'un nouvel objet référencé par p2")
    p2 = Point(8)
    print("Nouvelles coordonnées")
    print(p2.x)
    print(p2.y)

    